
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>gawk 文本处理入门用法详集 / 憋错料</title>

    <meta name="description" content="gawk 文本处理入门用法详集 awk笔记 gawk - pattern scanning and processing language 报告生成器,可进行格式化输出,文本处理三剑客之一,是基于sed和grep功能的扩展 一般用法格式: awk [options] 'program' FILE...     program: /regular/{print} 语句之间用分号分隔    print,printf 选项: -F:指明输入时用到的字段    -v var=value:指明自定变量 awk运作方式: 逐行读入文本,并">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">gawk 文本处理入门用法详集</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>awk笔记</p>
<h2>gawk - pattern scanning and processing language</h2>
<h4>报告生成器,可进行格式化输出,文本处理三剑客之一,是基于sed和grep功能的扩展</h4>
<p><strong>一般用法格式:</strong></p>
<pre>awk&nbsp;[options]&nbsp;‘program‘&nbsp;FILE...
&nbsp;&nbsp;&nbsp;&nbsp;program:&nbsp;/regular/{print}</pre>
<blockquote><p>语句之间用分号分隔<br /> &nbsp; &nbsp;print,printf</p></blockquote>
<p><strong>选项:</strong></p>
<blockquote><p>-F:指明输入时用到的字段<br /> &nbsp; &nbsp;-v var=value:指明自定变量</p></blockquote>
<h5>awk运作方式:</h5>
<blockquote><p>逐行读入文本,并将每个字段给予一个变量进行存储,$1..$NF ,而$0标识一整行<br /> &nbsp; &nbsp;显示文本的的2,4字段,默认是空格为分隔符,默认输出以空格为分隔符</p></blockquote>
<pre>tail&nbsp;-3&nbsp;/etc/fstab&nbsp;&nbsp;|&nbsp;awk&nbsp;‘{print&nbsp;$2,$4}‘</pre>
<blockquote><p>1.print item1,item2...</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;以逗号作为分隔符
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;变量的引用,不允许在""内部
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;省略item,则默认print&nbsp;$0</pre>
<blockquote><p>2.变量</p></blockquote>
<p><strong>1.内键变量</strong></p>
<blockquote><p>FS:input field seperator指明输入字段分隔符类似-F<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;OFS:output field seprator 指明输出字段分隔符<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;RS:input record seperator输入时的换行符</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-v&nbsp;RS=‘&nbsp;‘&nbsp;‘{print}‘&nbsp;&nbsp;/etc/passwd</pre>
<blockquote><p>ORS:output record seperator输出时的换行符<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;NF:number of field,每行的字段数量<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;$NF:最后一个字段<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;NR:number of record,行数<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;FNR:各文件分别计数<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;FILENAME:当前的文件名<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;ARGC:命令行参数的个数(program 不为参数)</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;‘BEGIN{print&nbsp;ARGC}‘&nbsp;/etc/fstab</pre>
<blockquote><p>ARGV:数组,保存,命令行中所给定的每个字段</p></blockquote>
<p><strong>2.自定义变量</strong></p>
<blockquote><p>-v var=value<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;变量名区分大小写</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-v&nbsp;test=‘hello&nbsp;gawk‘&nbsp;‘BEGIN{print&nbsp;test}</pre>
<blockquote><p>在program中直接定义</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;‘BEGIN{test="hello&nbsp;gawk";print&nbsp;test}‘</pre>
<p><strong>3.printf命令:格式化输出</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;printf&nbsp;"FORMAT1,FORMAT2",item1,item2...&nbsp;===&gt;FORMAT与item对应位置的格式化
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1.FORMAT是必须要给出
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.printf不自动换行,显式给出换行符\n
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.FORMAT需要分别为后面的每个item指定一个格式化符号</pre>
<h6>格式符(需用双引号):</h6>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%c&nbsp;:显示字符的ASCII码
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%d&nbsp;%i:显示十进制整数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%e&nbsp;%E:科学计数法数值显示
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%f:显示浮点数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%g,%G:以科学计数法或浮点数显示数值
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s:显示字符串
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%u:无符号整数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%%:显示%自身</pre>
<blockquote><p>格式化输出示例:</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘{printf&nbsp;"Username:&nbsp;%s\n",$1}‘&nbsp;/etc/passwd</pre>
<h6>修饰符:加在格式符之前,用于控制格式符的显示方式</h6>
<p><em>#.# &nbsp;第一个数字控制显示宽度;第二个#表示小数点后的精度</em></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%3.2f
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;:&nbsp;显示为左对齐
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;+&nbsp;:&nbsp;显示数值的符号,有正数负数之分</pre>
<p><em>示例:</em></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-v&nbsp;FS=‘:‘&nbsp;‘{printf&nbsp;"username:&nbsp;%-25s,UDI:&nbsp;%-25d\n",$1,$3}‘&nbsp;/etc/passwd</pre>
<p><strong>4.操作符</strong></p>
<p><strong>算术操作符</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;x+y,x-y,x*y,x^y,x/y,x%y
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;-x:正数转化为负数
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;+x:字符串转化为数值</pre>
<p><strong>字符串操作符:没有符号的操作符,字符串的连接</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;赋值操作符:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=,+=,-=,*=,/=,%=,^=
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;++,--
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;比较操作符:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&gt;,&lt;,&gt;=,&lt;=,!=,==
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;模式匹配符:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~:是否匹配
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;!~:是否不匹配
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;逻辑操作符:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&amp;&amp;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;||
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;!</pre>
<p><strong>函数调用:</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;function_name(argu1,argu2,...)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;条件表达式:(三目运算)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;selctor?if-true-expression:if-false-expression</pre>
<p><strong>示例:</strong>查找本机的普通用户及系统用户</p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;#&nbsp;awk&nbsp;-F:&nbsp;-v&nbsp;OFS=":"&nbsp;&nbsp;‘{$3&gt;1000?usertype="common&nbsp;user":usertype="system&nbsp;user";printf&nbsp;"%-18s,%s\n",$1,usertype}‘&nbsp;/etc/passwd</pre>
<p><strong>5.PATTERN</strong></p>
<blockquote><p>1 .empty:空模式,匹配每一行</p>
<p>2 ./regular expression/:文本过滤仅处理被模式匹配到的行</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;‘/^UUID/{print&nbsp;$1}‘&nbsp;/etc/fstab</pre>
<blockquote><p>3 .relatinal expression:关系表达式:结果为真式,才会被处理;非零为真</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;&nbsp;‘$3&gt;=1000{print&nbsp;$1,$3}‘&nbsp;/etc/passwd</pre>
<blockquote><p>查找其用户的默认shell为/bin/bash的用户</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘$NF=="/bin/bash"{print&nbsp;$1,$NF}‘&nbsp;/etc/passwd
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘$NF~/bash$/{print&nbsp;$1,$NF}‘&nbsp;/etc/passwd</pre>
<blockquote><p>4 .lines ranges:行范围<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;startline,endline<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;注意:不支持直接指定数字,可以容如下方式</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘(NR&gt;=2&amp;&amp;NR&lt;=5){print&nbsp;$1,$2}‘&nbsp;/etc/passwd
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/part1/,/part2/
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘/^h/,/^9/{print&nbsp;$1}‘&nbsp;/etc/passwd</pre>
<blockquote><p>5 .BEGIN/END模式:处理开始之前处理一次<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;BEGIN{}:仅在开始处理文件中的文件之前执行一次:<br /> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;END{}:仅在文本处理完成之后执行一次</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘BEGIN{print&nbsp;"username&nbsp;uid&nbsp;\n----------"}{print&nbsp;$1,$3‘&nbsp;/etc/passwd</pre>
<blockquote><p>6 .常用的action:</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1.expressions
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.control&nbsp;statements:if&nbsp;,while,等;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3.compound&nbsp;statements:组合语句;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4.input&nbsp;statements
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5.output&nbsp;statements</pre>
<blockquote><p>7 .控制语句</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(condition)&nbsp;{statements}&nbsp;else&nbsp;{statments}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;while(condition)&nbsp;{statements}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;for(expr1;expr2;expr3)&nbsp;{statements}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{statements}组合语句需要{}</pre>
<ol>
<li>if-else</p>
<blockquote><p>语法: if(condition) statements [else statements]</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;awk&nbsp;-F:&nbsp;‘{if($3&gt;=1000)&nbsp;{printf&nbsp;"common&nbsp;user:%s\n",$1}&nbsp;else&nbsp;{printf&nbsp;"system&nbsp;user:&nbsp;%s\n&nbsp;",$1}}‘&nbsp;/etc/passwd</pre>
<blockquote><p>取得磁盘利用率:</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;]#&nbsp;df&nbsp;-h|&nbsp;awk&nbsp;-F&nbsp;[%]&nbsp;‘/^\/dev/{print&nbsp;$1}‘|awk&nbsp;‘{if($NF&gt;=10)&nbsp;print&nbsp;$1}‘</pre>
</li>
<li>while循环:<br />
<blockquote><p>语法:while(condition) statements</p></blockquote>
<p>条件为"真",进入循环;条件为假则退出循环<br /> 使用场景:对一行内的多个字段逐一处理,对数组中的字段做逐一处理</p>
<p>函数:length()字符长度</p>
<blockquote><p>统计每个字段的长度?</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘/[[:space:]]*linux16/{i=1;while(i&lt;=NF)&nbsp;{print&nbsp;$i,length($i);i++}}‘&nbsp;/etc/grub2.cfg</pre>
<blockquote><p>并统计出大于7的字段?</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘/[[:space:]]*linux16/{i=1;while(i&lt;=NF)&nbsp;{if(length($i)&gt;=7)&nbsp;{print&nbsp;$i,length($i)};i++}}‘&nbsp;/etc/grub2.cfg</pre>
</li>
<li>do-while循环
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;语法:do&nbsp;statement&nbsp;while(condition)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;意义:先执行循环语句,而后在判断执行while循环</pre>
</li>
<li>for循环:<br />
<blockquote><p>语法:for(expr1;expr2;expr3) statement<br />for(variable assignment;condition;iteration proccess) {for-body}</p></blockquote>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘/[[:space:]]*linux16/{for(i=1;i&lt;=NF;i++)&nbsp;{print&nbsp;$i,length($i)}}‘&nbsp;/etc/grub2.cfg</pre>
<p>特殊用法:<br /><em>能够遍历数组中的元素:</em></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;for(var&nbsp;in&nbsp;array)&nbsp;{for-body}</pre>
</li>
<li>switch语句:
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;语法:&nbsp;switch(expression)&nbsp;{case&nbsp;VALUE1&nbsp;or&nbsp;/REGEXP/:statement;case&nbsp;VALUE2&nbsp;or&nbsp;/REGEXP/:statement...;default&nbsp;statement}</pre>
</li>
<li>break和continue
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break&nbsp;[n]&nbsp;:跳出n层循环</pre>
</li>
<li>next
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;提前结束对本行的处理而直接进入下一行
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;仅显示偶数的uid用户?
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;-F:&nbsp;‘{if($3%2!=0)&nbsp;next;&nbsp;print&nbsp;$1,$3}‘&nbsp;/etc/passwd</pre>
</li>
<li>array<br /> 关联数组:array[index-expression]
<pre>&nbsp;index-expression:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1.可使用任意字符串;索引要使用双引号"";array["mon"]=Monday
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.如果某元素事先不存在,在引用时awk会自动将此元素创建并将其赋值为空串</pre>
</li>
</ol>
<blockquote><p>若要判断数组中是否存在某元素,要使用"index in array"格式进行<br /> &nbsp; &nbsp; &nbsp; &nbsp;若要遍历数组中的每个元素,要使用for循环:</p></blockquote>
<p><strong>for(var in array) {for-body}</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘BEGIN{weekdays["mon"]="monday";weekdays["tue"]="tuesday";for(i&nbsp;in&nbsp;weekdays)&nbsp;{print&nbsp;weekdays[i]}}‘
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;注意:var会遍历array的每个索引;</pre>
<p><strong>查看netstat -nat中tcp状态出现的次数?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;netstat&nbsp;-tan&nbsp;|awk&nbsp;‘/^tcp\&gt;/{state[$NF]++}END{for(i&nbsp;in&nbsp;state)&nbsp;{print&nbsp;i,state[i]}}‘</pre>
<p><strong>查看ss -nat中tcp状态出现的次数?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;ss&nbsp;-tan&nbsp;|awk&nbsp;‘{state[$1]++}END{for(i&nbsp;in&nbsp;state)&nbsp;{print&nbsp;i,state[i]}}‘</pre>
<p><strong>查看ip地址的访问量?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘{ip[$1]++}END{for(i&nbsp;in&nbsp;ip)&nbsp;{print&nbsp;i,ip[i]}}‘&nbsp;/var/log/httpd/access_log</pre>
<p><strong>统计/etc/fstab中文件系统的个数?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘/^UUID/{fs[$3]++}END{for(i&nbsp;in&nbsp;fs)&nbsp;{print&nbsp;i,fs[i]}}‘&nbsp;/etc/fstab</pre>
<p><strong>统计指定文件中每个单词出现的次数?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;awk&nbsp;‘{for(i=1;i&lt;=NF;i++)&nbsp;{count[$i]++}}END{for(i&nbsp;in&nbsp;count)&nbsp;{print&nbsp;i,count[i]}}‘&nbsp;/etc/fstab</pre>
<p><strong>9.内置函数:</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;数值处理:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rand():返回指定字符串的长度;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;字符处理:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;length([s]):返回指定字符串的长度;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;sub(r,s,[t]):以r表示模式查找t所表示的字符中匹配的内容,并将其第一次出现替换为s所表示的内容;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;gsub(r,s,[t]):以r表示模式查找t所表示的字符中匹配的内容,并将全局出现替换为s所表示的内容;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;splits(s,a[,r]):以r为分隔符切割字符s,并将切割后的结果保存至a所代表的的数组中</pre>
<p><strong>统计ip地址出现的次数?</strong></p>
<pre>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;~]#&nbsp;netstat&nbsp;-tan|awk&nbsp;‘/^tcp\&gt;/{split($5,ip,":");count[ip[1]]++}END{for(i&nbsp;in&nbsp;count)&nbsp;{print&nbsp;i,count[i]}}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 19:07:27 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.biecuoliao.com/tag/awk/" title="awk">awk</a>, <a href="https://www.biecuoliao.com/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>gawk 文本处理入门用法详集的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qE1ON3.html" rel="bookmark">Node&period;js开发入门&mdash;Stream用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Stream是Node.js中非常重要的一个模块,应用广泛.一个流是一个具备了可读.可写或既可读又可写能力的接口,通过这些接口,我们可以和磁盘文件.套接字.HTTP请求来交互,实现数据从一个地方流动到另一个地方的功能. 所有的流都实现了EventEmitter的接口,具备事件能力,通过发射事件来反馈流的状态.比如有错误发生时会发射&quot;error&quot;事件,有数据可被读取时发射&quot;data&quot;事件.这样我们就可以注册监听器来处理某个事件,达到我们的目的. Node.js定义了R			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NWqEZM.html" rel="bookmark">详解Linux中的cat文本输出命令用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作系统 &gt; LINUX &gt; 详解Linux中的cat文本输出命令用法 Linux命令手册   发布时间:2016-01-14 14:14:35   作者:张映    我要评论 这篇文章主要介绍了Linux中的cat文本输出命令用法,是Linux入门学习中的基础知识,需要的朋友可以参考下 cat命令是linux下的一个文本输出命令,通常是用于观看某个文件的内容的.一.功能cat主要有三大功能:1.一次显示整个文件. 复制代码 代码如下: $ cat filename 2.从键盘创建一个文件. 复			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RBlg90.html" rel="bookmark">C&num; ListView用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.ListView类 1.常用的基本属性: (1)FullRowSelect:设置是否行选择模式.(默认为false) 提示:只有在Details视图该属性才有意义. (2) GridLines:设置行和列之间是否显示网格线.(默认为false)提示:只有在Details视图该属性才有意义. (3)AllowColumnReorder:设置是否可拖动列标头来对改变列的顺序.(默认为false)提示:只有在Details视图该属性才有意义. (4)View:获取或设置项在控件中的显示方式,包括D			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35XPQV0.html" rel="bookmark">转：sql cast和convert用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://www.2cto.com/database/201310/250880.html sql cast和convert用法详解 总结: 以下这条仅仅适用于mysql SELECT {fn CONCAT(CONVERT(user_id,CHAR),USER_NAME)} AS str FROM t_sys_user 以下这条仅仅适用于sqlserver2008 SELECT {fn CONCAT(CONVERT(CHAR,user_id),USER_NAME)} AS str FR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A5yra4.html" rel="bookmark">&lbrack;转载&rsqb;ssget 用法详解 by yxp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总结得很好的ssget用法.....如此好文,必须转载. 原文地址: http://blog.csdn.net/yxp_xa/article/details/72229202 ssget 用法详解 by yxp 2017/04/10 ALisp 编程时 ssget 是无处不在的,灵活的选择集构建方式,可以轻松的处理图形,体现了 Lisp 相对其他语言的优点. 然而强大的 ssget 估计很多人都不清楚用法,包括各种教程对 ssget 的描述都不够完善,本文试图总结 ssget 的用法,不足之处请			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/N4p168M.html" rel="bookmark">jQuery 事件用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				jQuery 事件用法详解 目录 简介 实现原理 事件操作 绑定事件 解除事件 触发事件 事件委托 事件操作进阶 阻止默认事件 阻止事件传播 阻止事件向后执行 命名空间 自定义事件 事件队列 jquery中文文档 简介 jquery 之所以成为最受欢迎的前端库,很大一部分是得益于它的事件具有良好的语义,优秀的兼容性,并且便于管理和扩展. 在这里我会介绍 jquery 事件的一些比较基础的用法. 实现原理 jquery 事件脱胎于浏览器的 addEventListener (W3) 和 attac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lWDwBM.html" rel="bookmark">一步一步学ios UITextView&lpar;多行文本框&rpar;控件的用法详解&lpar;五5&period;8&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文转载至 http://wuchaorang.2008.blog.163.com/blog/static/48891852201232014813990/ 1.创建并初始化 创建UITextView的文件,并在.h文件中写入如下代码: [csharp] view plaincopy #import &lt;UIKit/UIKit.h&gt; @interface TextViewController : UIViewController &lt;UITextViewDelegate&gt; { UITe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NGO7VM.html" rel="bookmark">selenium用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				selenium用法详解 selenium主要是用来做自动化测试,支持多种浏览器,爬虫中主要用来解决JavaScript渲染问题. 模拟浏览器进行网页加载,当requests,urllib无法正常获取网页内容的时候 一.声明浏览器对象 注意点一,Python文件名或者包名不要命名为selenium,会导致无法导入 from selenium import webdriver #webdriver可以认为是浏览器的驱动器,要驱动浏览器必须用到webdriver,支持多种浏览器,这里以Chrome为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nkleV3.html" rel="bookmark">delphi TStringList 用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				delphi TStringList 用法详解. TStringList 常用方法与属性 : var List: TStringList; i: Integer; begin List := TStringList.Create; List.Add('Strings1'); {添加} List.Add('Strings2'); List.Exchange(0,1); {置换} List.Insert(0,'Strings3'); {插入} i := List.IndexOf('Strings1'			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8pdq3.html" rel="bookmark" class="title">git merge以及比较两个repo</a>
					<div>
						一.需求 1)有两个相关的branch github下载的repo有master和work两个分支,由于远端已经更新,master分支落后于远端分支,work分支又有新的更新内容,需要将远端maste ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2NQg3.html" rel="bookmark" class="title">java&period;util&period;Scanner应用详解&plus;&plus;扫描控制台输入</a>
					<div>
						java.util.Scanner应用详解 java.util.Scanner是Java5的新特征,主要功能是简化文本扫描.这个类最实用的地方表现在获取控制台输入,其他的功能都很鸡肋,尽管Java A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgGGm3.html" rel="bookmark" class="title">delegate Notification  KVO</a>
					<div>
						区别: delegate 的 优势 : 1.非常严格的语法.所有将听到的事件必须是在delegate协议中有清晰的定义. 2.如果delegate中的一个方法没有实现那么就会出现编译警告/错误 3.协 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnezQ3.html" rel="bookmark" class="title">vc连接sqlite数据库</a>
					<div>
						mnesia在频繁操作数据的过程可能会报错:** WARNING ** Mnesia is overloaded: {dump_log, write_threshold},可以看出,mnesia应该是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjnzQ0.html" rel="bookmark" class="title">&lbrack;C&plus;&plus;&rsqb; smart pointer</a>
					<div>
						写在前面的话: 智能指针的设计意图:C++没有垃圾回收机制,所有的动态内存释放全部由程序员负责,如果程序员没有释放内存,就会造成内存泄漏,这是C++ BUG的一大来源.为了管理动态内存,引入了智能指针 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzqOZ3.html" rel="bookmark" class="title">ubuntu 双屏问题的解决方案</a>
					<div>
						ubuntu有一个很让人头疼的问题就是它默认开启双屏.只要你有两个显示器接口,即使你没有两块屏幕,它也是按照双屏幕去显示. 这就会造成一些很让人无语的问题,比如,恰好跳到你没有的那个屏幕就可能导致无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLez83.html" rel="bookmark" class="title">在服务器端的远程对象中加上抽象工厂的接口和实现类</a>
					<div>
						public interface IServerObject { Person GetPersonInfo(string name,string sex,int age); } public inte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6l9d53.html" rel="bookmark" class="title">Hadoop集群（第9期）&lowbar;MapReduce初级案例 - 虾皮 - 博客园</a>
					<div>
						body{ font-family: &quot;Microsoft YaHei UI&quot;,&quot;Microsoft YaHei&quot;,SimSun,&quot;Segoe UI& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pE8R3.html" rel="bookmark" class="title">ps图片怎样实现渐变</a>
					<div>
						首先我先将一副图片展示给大家: 我所做的效果是想把图片做成渐变.而不改变中间图片的颜色效果. 接下来我来说明一下我的所做思路. 首先将图片中间部分选择出来.然后复制成一个图层. 详细操作是用魔棒进行反 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRmkr4.html" rel="bookmark" class="title">JavaMail发送简单邮件</a>
					<div>
						Properties props = new Properties();// 回话Session session = Session.getInstance(props);session.setDeb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jrlZ90.html" rel="bookmark" class="title">java中动态代理的实现</a>
					<div>
						动态代理的实现 使用的模式:代理模式.代理模式的作用是:为其他对象提供一种代理以控制对这个对象的访问.类似租房的中介. 两种动态代理:(1)jdk动态代理,jdk动态代理是由Java内部的反射机制来实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPn9lM.html" rel="bookmark" class="title">MYSQL远程登录权限设置 ，可以让Navicat远程连接服务器的数据库</a>
					<div>
						Mysql默认关闭远程登录权限,如下操作允许用户在任意地点登录: 1. 进入mysql,GRANT ALL PRIVILEGES ON *.* TO 'root'@'%' IDENTIFIED BY  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkGxW0.html" rel="bookmark" class="title">&lbrack;Tango&rsqb; Basic Knowledge</a>
					<div>
						Project Tango类设备能够给开发者在哪些领域带来机会. 室内导航*:室内GPS信号的缺失,使得Project Tango设备会成为室内导航重要应用场景之一.有了它,你就不会在不熟悉的室内商场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OXQv74.html" rel="bookmark" class="title">【SICP练习】137 练习3&period;68</a>
					<div>
						练习3-68 原文 Exercise 3.68. Louis Reasoner thinks that building a stream of pairs from three parts is u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NQWgZ3.html" rel="bookmark" class="title">save</a>
					<div>
						using (DataContext dbcontext=new DataContext ()) { //emp.department.ID = dep.ID; //emp.department =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QPgPE3.html" rel="bookmark" class="title">排序算法&lpar;一&rpar;3种简单排序&lpar;选择，冒泡，插入&rpar;</a>
					<div>
						排序是数据处理中十分常见且核心的操作,虽说实际项目开发中很小几率会需要我们手动实现,毕竟每种语言的类库中都有n多种关于排序算法的实现.但是了解这些精妙的思想对我们还是大有裨益的.本文简单温习下最基础的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rDxzlM.html" rel="bookmark" class="title">c&plus;&plus; pb&lowbar;ds库，实现 红黑树，Splay</a>
					<div>
						C++ pb_ds库 #include &lt;ext/pb_ds/assoc_container.hpp&gt;#include &lt;ext/pb_ds/tree_policy.hpp&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A2G55M.html" rel="bookmark" class="title">手机站横向滚动</a>
					<div>
						写手机站时我们会遇到像这样的左右滑动的效果,刚开始还误以为是某个js效果,后来才知道,原来是css就可以实现的. * {margin: 0;padding: 0;} .box {width: 100% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPOyBB4.html" rel="bookmark" class="title">iOSAPP启动时实现加载广告</a>
					<div>
						现在很多APP在启动的时候都在加载广告,现在也很流行,主要是盈利啊.笔者也做了很多关于广告的事情.现在记录下自己在APP启动的时候,怎么加载广告的. 下面总结下广告加载的三种方式 1.现在很多APP的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lLnAo0.html" rel="bookmark" class="title">Javascript&amp;amp&semi;Jquery获取浏览器和屏幕各种高度宽度方法总结及运用</a>
					<div>
						&lt;js篇&gt; Javascript获取浏览器和屏幕各种高度宽度方法总结 document.body.clientWidth       //网页可见区域宽(body) document.bo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
